codeforces888G Xor-MST

5 篇文章 0 订阅
2 篇文章 0 订阅
G. Xor-MST
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

You are given a complete undirected graph with n vertices. A number ai is assigned to each vertex, and the weight of an edge between vertices i and j is equal to aixor aj.

Calculate the weight of the minimum spanning tree in this graph.

Input

The first line contains n (1 ≤ n ≤ 200000) — the number of vertices in the graph.

The second line contains n integers a1a2, ..., an (0 ≤ ai < 230) — the numbers assigned to the vertices.

Output

Print one number — the weight of the minimum spanning tree in the graph.

Examples
input
Copy
5
1 2 3 4 5
output
8
input
Copy
4
1 2 3 4
output
8

题意:给你n个点的点权,连接两个点的代价为ai^aj,求最小生成树。

我们可以按位进行计算,把0和1分开递归,如果只有最低位不一样,那么一定要连边。

在合并的时候,我们要把1中一个数和0中一个数能够得到的异或最小值合并,我们用01trie树进行查询即可,每层暴力建树,下一层就要把树销毁。

这样的贪心是对的,因为二进制一个数字比地位所有数字加起来还要大。

我们每次都把能用到的最小代价用到了,所以不会错。

代码:

#include<bits/stdc++.h>
using namespace std;
int nex[7000005][2],tot,a[200005],n;
long long ans=0;
void ins(int x)
{
    int now=0;
    for(int i=29;i>=0;i--)
    {
        int t=(x>>i)&1;
        if(nex[now][t]==0) nex[now][t]=++tot;
        now=nex[now][t];
    }
}
int ask(int x)
{
    int res=0,now=0;
    for(int i=29;i>=0;i--)
    {
        int t=(x>>i)&1;
        if(nex[now][t]) now=nex[now][t];
        else now=nex[now][t^1],res|=(1<<i);
    }
    return res;
}
void dfs(int l,int r,int dep)
{
    if(dep==-1||l>=r) return;
    int mid=l-1;
    while(mid<r&&(a[mid+1]>>dep&1)==0) mid++;
    dfs(l,mid,dep-1),dfs(mid+1,r,dep-1);
    if(mid==l-1||mid==r) return;
    for(int i=l;i<=mid;i++) ins(a[i]);
    int res=2147483647;
    for(int i=mid+1;i<=r;i++) res=min(res,ask(a[i]));
    ans+=res;
    for(int i=0;i<=tot;i++) nex[i][0]=nex[i][1]=0;
    tot=0;
}
int main()
{
    cin>>n;
    for(int i=1;i<=n;i++) scanf("%d",&a[i]);
    sort(a+1,a+n+1);
    dfs(1,n,29);
    cout<<ans<<endl;
}


CodeForces - 616D是一个关于找到一个序列中最长的第k好子段的起始位置和结束位置的问题。给定一个长度为n的序列和一个整数k,需要找到一个子段,该子段中不超过k个不同的数字。题目要求输出这个序列最长的第k好子段的起始位置和终止位置。 解决这个问题的方法有两种。第一种方法是使用尺取算法,通过维护一个滑动窗口来记录\[l,r\]中不同数的个数。每次如果这个数小于k,就将r向右移动一位;如果已经大于k,则将l向右移动一位,直到个数不大于k。每次更新完r之后,判断r-l+1是否比已有答案更优来更新答案。这种方法的时间复杂度为O(n)。 第二种方法是使用枚举r和双指针的方法。通过维护一个最小的l,满足\[l,r\]最多只有k种数。使用一个map来判断数的种类。遍历序列,如果当前数字在map中不存在,则将种类数sum加一;如果sum大于k,则将l向右移动一位,直到sum不大于k。每次更新完r之后,判断i-l+1是否大于等于y-x+1来更新答案。这种方法的时间复杂度为O(n)。 以上是两种解决CodeForces - 616D问题的方法。具体的代码实现可以参考引用\[1\]和引用\[2\]中的代码。 #### 引用[.reference_title] - *1* [CodeForces 616 D. Longest k-Good Segment(尺取)](https://blog.csdn.net/V5ZSQ/article/details/50750827)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] - *2* [Codeforces616 D. Longest k-Good Segment(双指针+map)](https://blog.csdn.net/weixin_44178736/article/details/114328999)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值